diff --git a/inet/Makefile b/inet/Makefile
index bd2fc317b5..1ca06bba80 100644
--- a/inet/Makefile
+++ b/inet/Makefile
@@ -36,10 +36,11 @@ routines := htonl htons		\
 	    getnetbynm_r \
 	    getproto getproto_r getprtent getprtent_r getprtname getprtname_r \
 	    getsrvbynm getsrvbynm_r getsrvbypt getsrvbypt_r getservent \
-	    getservent_r	\
+	    getservent_r getrpcent getrpcbyname getrpcbynumber \
+	    getrpcent_r getrpcbyname_r getrpcbynumber_r \
 	    ether_aton ether_aton_r ether_hton ether_line \
 	    ether_ntoa ether_ntoa_r ether_ntoh \
-	    rcmd rexec ruserpass \
+	    rcmd rexec ruserpass bindresvport \
 	    getnetgrent_r getnetgrent \
 	    getaliasent_r getaliasent getaliasname getaliasname_r \
 	    in6_addr getnameinfo if_index ifaddrs inet6_option \
@@ -47,6 +48,8 @@ routines := htonl htons		\
 	    getsourcefilter setsourcefilter inet6_opt inet6_rth \
 	    inet6_scopeid_pton deadline idna idna_name_classify
 
+install-others = $(inst_sysconfdir)/rpc
+
 aux := check_pf check_native ifreq
 
 tests := htontest test_ifindex tst-ntoa tst-ether_aton tst-network \
@@ -108,6 +111,10 @@ CFLAGS-tst-sockaddr.c += -fno-strict-aliasing
 
 endif
 
+# Install the rpc database file.
+$(inst_sysconfdir)/rpc: etc.rpc $(+force)
+	$(do-install)
+
 ifeq ($(build-static-nss),yes)
 CFLAGS += -DSTATIC_NSS
 endif
diff --git a/sunrpc/bindrsvprt.c b/inet/bindresvport.c
similarity index 100%
rename from sunrpc/bindrsvprt.c
rename to inet/bindresvport.c
diff --git a/sunrpc/etc.rpc b/inet/etc.rpc
similarity index 100%
rename from sunrpc/etc.rpc
rename to inet/etc.rpc
diff --git a/sunrpc/getrpcbyname.c b/inet/getrpcbyname.c
similarity index 100%
rename from sunrpc/getrpcbyname.c
rename to inet/getrpcbyname.c
diff --git a/sunrpc/getrpcbyname_r.c b/inet/getrpcbyname_r.c
similarity index 100%
rename from sunrpc/getrpcbyname_r.c
rename to inet/getrpcbyname_r.c
diff --git a/sunrpc/getrpcbynumber.c b/inet/getrpcbynumber.c
similarity index 100%
rename from sunrpc/getrpcbynumber.c
rename to inet/getrpcbynumber.c
diff --git a/sunrpc/getrpcbynumber_r.c b/inet/getrpcbynumber_r.c
similarity index 100%
rename from sunrpc/getrpcbynumber_r.c
rename to inet/getrpcbynumber_r.c
diff --git a/sunrpc/getrpcent.c b/inet/getrpcent.c
similarity index 100%
rename from sunrpc/getrpcent.c
rename to inet/getrpcent.c
diff --git a/sunrpc/getrpcent_r.c b/inet/getrpcent_r.c
similarity index 100%
rename from sunrpc/getrpcent_r.c
rename to inet/getrpcent_r.c
diff --git a/sunrpc/Makefile b/sunrpc/Makefile
index d5840d0770..2d1861f3dc 100644
--- a/sunrpc/Makefile
+++ b/sunrpc/Makefile
@@ -32,7 +32,6 @@ include ../Makeconfig
 # file name limits:
 #
 #	authunix_prot.c -> authuxprot.c
-#	bindresvport.c -> bindrsvprt.c
 #	clnt_generic.c -> clnt_gen.c
 #	clnt_perror.c -> clnt_perr.c
 #	clnt_simple.c -> clnt_simp.c
@@ -54,7 +53,6 @@ headers-sunrpc = $(addprefix rpc/,auth.h auth_unix.h clnt.h pmap_clnt.h \
 				  key_prot.h) \
 		       $(rpcsvc:%=rpcsvc/%) rpcsvc/bootparam.h
 headers = rpc/netdb.h
-install-others = $(inst_sysconfdir)/rpc
 generated += $(rpcsvc:%.x=rpcsvc/%.h) $(rpcsvc:%.x=x%.c) $(rpcsvc:%.x=x%.stmp) \
 	     $(rpcsvc:%.x=rpcsvc/%.stmp) rpcgen
 generated-dirs += rpcsvc
@@ -70,13 +68,11 @@ need-export-routines := auth_des auth_unix clnt_gen clnt_perr clnt_tcp \
 			xdr_intXX_t xdr_mem xdr_ref xdr_sizeof xdr_stdio \
 			svc_run
 
-routines := auth_none authuxprot bindrsvprt clnt_raw clnt_simp \
+routines := auth_none authuxprot clnt_raw clnt_simp \
 	    rpc_dtable getrpcport pmap_clnt pm_getmaps pmap_prot pmap_prot2 \
 	    pmap_rmt rpc_prot rpc_common rpc_cmsg svc_auth svc_authux svc_raw \
 	    svc_simple xdr_float xdr_rec publickey authdes_prot \
 	    des_crypt des_impl des_soft key_prot openchild rtime svcauth_des \
-	    getrpcent getrpcbyname getrpcbynumber \
-	    getrpcent_r getrpcbyname_r getrpcbynumber_r \
 	    clnt_unix svc_unix create_xid $(need-export-routines) \
 	    rpc_gethostbyname
 ifneq ($(link-obsolete-rpc),yes)
@@ -188,9 +184,6 @@ include $(patsubst %,$(..)libof-iterator.mk,$(cpp-srcs-left))
 # binary be the second dependency listed in each rule using rpcgen-cmd.
 rpcgen-cmd = CPP='$(CC) -E -x c-header' $(built-program-file) -Y ../scripts
 
-# Install the rpc data base file.
-$(inst_sysconfdir)/rpc: etc.rpc $(+force)
-	$(do-install)
 
 # Generate the rpcsvc headers with rpcgen.
 # We use a stamp file to avoid unnessary recompilation each time rpcgen is